/**
 * 
 */
package jdbcFinal;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;

/**
 * Entry point of the application which shows how-to use JDBC driver for
 * interacting with MySQL and Oracle DB databases.
 * 
 * @author Sukharev Dmitriy
 * 
 */
public class Main {

    /**
     * Uses entity of DatabasaManager interface for interacting with MySQL or
     * Oracle DB database using JDBC driver.
     * 
     * @param args
     */
    public static void main(String[] args) {
        String dbname = "XE";
        String tablename = "myFirstJDBC";
        DatabaseManager dbManager = new OracleDBManager();

        try {
            dbManager.loadDriver();

            Connection connection = null;
            try {
                connection = dbManager.connectToDB(dbname);
                if (!dbManager.isTableExists(connection, tablename)) {
                    dbManager.createTable(connection, tablename);
                }
                dbManager.insert(connection, tablename);
                dbManager.update(connection, tablename);
                dbManager.delete(connection, tablename);
                ResultSet resultSet = dbManager.fetch(connection, tablename);
                dbManager.printFetched(resultSet);
            } catch (SQLException e) {
                System.err.println("Error of connection or of query.");
                e.printStackTrace();
            } finally {
                if (connection != null) {
                    try {
                        dbManager.disconnectFromDB(connection);
                    } catch (SQLException e) {
                        System.err.println("Error of disconnection.");
                        e.printStackTrace();
                    }
                }
            }
        } catch (ClassNotFoundException e) {
            System.err.println("Driver wasn't load");
            e.printStackTrace();
        }
    }
}
